import processing.core.*; 
import processing.xml.*; 

import de.bezier.data.sql.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Yoon_Project2_Final extends PApplet {

// MAT 259 Data Visulization Winter 2012
// Project 2.
// by Yoon Chung Han


//import processing.opengl.*;

public void draw()
{
  // for animation
  float fTimeDiff = (float)(millis() - gnTimeStart)/1000.0f;
  
  background(0);
  
  pushMatrix();
  pushStyle();
  
  // list of years 
  for(int i = 0; i<7; i++) {
   //stroke(255);
   textFont(gFont1);
   fill(255);
   textAlign(CENTER, CENTER);
   text(years[i], (i*120)+180, height-70);
   }
   
   // list of musicians
   for(int i = 0; i<10; i++) {
     textFont(gFont1);
     fill(255);
     textAlign(LEFT, LEFT);
     text(musicians[i], 30, (i*60)+105);
   }
   
   // Title and copyright
   textFont(gFont2);
   textAlign(LEFT, LEFT);
   fill(200);
   text("Who is the most popular classical musician in Seattle?", 30,30,900,30);
   textFont(gFont1);
   textAlign(RIGHT, TOP);
   fill(100);
   text("Project 2: BiVariate 2D Spatial Map Project, MAT 259 Winter 2012", 500,730,500,730);
   text("by Yoon Chung Han", 500,740,500,740);
   text("Press Key 1,2,3,4 to change color", 500,40,500,40);
  
  // draw each bar of musician
  for(int i=0; i<7; i++)  {
    for(int j=0; j<12; j++)  {
    
    int nIdx   = i*12+j;
    int nWidth = (gnBarsWidth+gnBarsHSpace)*7*12 - 120+(i*12+j)*gnBarsWidth;
      
      for( int k=0; k<gpDataMatrices.length; k++ )  {

        pushMatrix();
        pushStyle();
        
        int nColor = (int)((float)gpDataMatrices[k][i][j]/(float)gpMaxDataMatrices*255.0f);  // mode 1
        int nHue = (int)(240.0f - (float)gpDataMatrices[k][i][j]/(float)gpMaxDataMatrices*240.0f);  // mode2
        float nColor2 = map(nColor, 0, 255, 50, 255); // mode3
        float nColor3 = map(nColor, 0, 255, 30, 255); // mode3

        int nAlpha = 255;
        float fDiff = fTimeDiff - gfAnimationProceedSpeed*nIdx;
        if( fDiff <= gfAnimationSpeed || fDiff >= .0f )  nAlpha = (int)(fDiff/gfAnimationSpeed*255.0f);
        
        // box
        if( gpBarsMouseEvent[k][i][j] == true )  {
          
          switch(gnColorMode)  {
            case 1:
              colorMode(RGB, 255);
              stroke(0, 0, 0, nAlpha);
              fill(255, 255, 255, nAlpha);
              break;
              
            case 2:  // hsb
              colorMode(HSB, 360, 255, 255, 255);
              stroke(nHue, 192, 255, nAlpha);
              fill(nHue, 255, 255, nAlpha);
              break;
              
              case 3:  // hsb
              colorMode(RGB, 255, 255, 255, 255);
              stroke(nColor2, nColor2, 0, nAlpha);
              fill(255, 255, 0, nAlpha);
              break;
              
              case 4:  // hsb
              colorMode(RGB, 255, 255, 255, 255);
              stroke(255, 0, 0, nAlpha);
              fill(255, 0, 0, nAlpha);
              break;
          }
          
        }
        else  {

          switch(gnColorMode)  {
            case 1:
              colorMode(RGB, 255);
              noStroke();
              fill(nColor, nColor, nColor, nAlpha);
              break;
              
            case 2:  // hsb
              colorMode(HSB, 360, 255, 255, 255);
              noStroke();
              fill(nHue, 255, 200, nAlpha);
              break;
              
               case 3:  // hsb
              colorMode(RGB, 255, 255, 255, 255);
              noStroke();
              fill(nColor2,nColor2, 0, nAlpha);
              break;
              
               case 4:  // hsb
              colorMode(RGB, 255, 255, 255, 255);
              noStroke();
              fill(nColor3, 0, 0, nAlpha);
              break;
          }
        }
        
        float fRectX       = gnBarsLeft + (float)nIdx*(gnBarsWidth+gnBarsHSpace);
        float fRectY       = gnBarsTop + k * (gnBarsHeight+gnBarsVSpace);
        float fRectWidth   = gnBarsWidth;
        float fRectHeight  = gnBarsHeight;
        noStroke();
        rect(fRectX, fRectY, fRectWidth, fRectHeight);
        
        popStyle();
        popMatrix();
          
      }  // for k
      
    }  // for j
  }  // for i
  
  // draw number onto the bar
  // (this should be done after drawing bars)
  textFont(gFont1);  // for rollover effect
  textAlign(RIGHT, TOP);
  for(int i=0; i<7; i++)  {
    for(int j=0; j<12; j++)  {
    
    int nIdx   = i*12+j;
    int nWidth = (gnBarsWidth+gnBarsHSpace)*7*12 - 120+(i*12+j)*gnBarsWidth;
      
      for( int k=0; k<gpDataMatrices.length; k++ )  {

        // mouse rollover
        if( gpBarsMouseEvent[k][i][j] == true )  {
          
          // text
          String strText = gpDataMatrices[k][i][j].toString();
          int nTextX = gnBarsLeft + nIdx*(gnBarsWidth+gnBarsHSpace) - gnBarsWidth*2;
          int nTextY = gnBarsTop + k * (gnBarsHeight+gnBarsVSpace) - 20;
          int nTextWidth = gnBarsWidth*4;
          int nTextHeight = 20;
          
          fill(0);
          text(strText, nTextX+1, nTextY+1, nTextWidth+1, nTextHeight+1 );
          fill(255,0,0);
         // textFont(gFont2);
          text(strText, nTextX, nTextY, nTextWidth, nTextHeight );
          
        }  // if
        
      }  // for k
      
    }  // for j
  }  // for i

  popMatrix();
  popStyle();
  
}
public void keyPressed()
{
  switch(key)
  {
    case '1':
      gnTimeStart = millis();
      gnColorMode = 1;
      break;
    
    case '2':
      gnTimeStart = millis();
      gnColorMode = 2;
      break;
      
      case '3':
      gnTimeStart = millis();
      gnColorMode = 3;
      break;
      
      case '4':
      gnTimeStart = millis();
      gnColorMode = 4;
      break;
      
    default:
      break;
  }
}
public void mouseMoved()
{
  int nX = floor( (float)(mouseX - gnBarsLeft) / (float)(gnBarsWidth+gnBarsHSpace) );
  int nY = floor( (float)(mouseY - gnBarsTop) / (float)(gnBarsHeight+gnBarsVSpace) );
    
  // inside
  if( nX >= 0 && nX < 12*7 && nY >= 0 && nY < gpDataMatrices.length )
  {
    int nYearIdx   = floor(nX / 12);
    int nMonthIdx  = nX % 12;

    // skip if same to previous val
    if( gnPrevYearIdx*12+gnPrevMonthIdx == nX && gnPrevY == nY )

      ;    
      
    else  {
      
//      println(nY+" "+nYearIdx+" "+nMonthIdx);
  
//      if( gnPrevY >= 0 && gnPrevYearIdx >= 0 && gnPrevMonthIdx >= 0 )
//        gpBarsMouseEvent[gnPrevY][gnPrevYearIdx][gnPrevMonthIdx] = false;  // disable effect

      for( int k=0; k<gpDataMatrices.length; k++ )
        for( int i=0; i<7; i++ )
          for( int j=0; j<12; j++ )
            gpBarsMouseEvent[k][i][j] = false;
        
      // enable effect
      gpBarsMouseEvent[nY][nYearIdx][nMonthIdx] = true;
      
      gnPrevY         = nY;
      gnPrevYearIdx   = nYearIdx;
      gnPrevMonthIdx  = nMonthIdx;
      
    }
  }
  // outside
  else
  {
    if( gnPrevY >= 0 && gnPrevYearIdx >= 0 && gnPrevMonthIdx >= 0 )
      gpBarsMouseEvent[gnPrevY][gnPrevYearIdx][gnPrevMonthIdx] = false;
  }
}
// data matrices
Integer [][][] gpDataMatrices    = null;
Integer [][] pResult_Bach        = null;
Integer [][] pResult_Beethoven   = null;
Integer [][] pResult_Chopin      = null;
Integer [][] pResult_Handel      = null;
Integer [][] pResult_Haydn       = null;
Integer [][] pResult_Mozart      = null;
Integer [][] pResult_Schubert    = null;
Integer [][] pResult_Schumann    = null;
Integer [][] pResult_Stravinsky  = null;
Integer [][] pResult_Tchaikovsky = null;


int gpMaxDataMatrices = 0;

// mysql
MySQL msql = null;
String MySQL_host = "tango.mat.ucsb.edu";
String MySQL_user = "mat259";
String MySQL_pass = "V1sual1zat1on";
String MySQL_database = "spl_years";

// variables
float horizontalSquareSize;
float horizontalGridDivisions = 84;
int padding = 10;
int graphW = 850;
int graphH = 100;
int marginTop = 60;
int marginLeft = 90;
int spacing = 2;
int spacingln = 2;
int barW = 4;
final int cGraph = 0xff8E8E66;

// bars
int gnBarsLeft   = 120;
int gnBarsTop    = 80;
int gnBarsWidth  = 9;
int gnBarsHeight = 57;
int gnBarsHSpace = 1;
int gnBarsVSpace = 2;

// event: mouse rollover
boolean[][][] gpBarsMouseEvent = null;
int           gnPrevY = -1;
int           gnPrevYearIdx = -1;
int           gnPrevMonthIdx = -1;

// event: keyboard
int gnColorMode = 1;

// event: animation
float gfAnimationProgress = .0f;
float gfAnimationProceedSpeed = 0.025f;  // 84 * 0.025f = 2.1s
float gfAnimationSpeed = 0.3f;  // drawing one bar by 0.25s
int   gnTimeStart = 0;

// strings
String[] months = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
String[] years = {"2005", "2006", "2007", "2008", "2009", "2010", "2011"};
String[] musicians = {"Bach","Beethoven","Chopin","Handel","Haydn","Mozart","Schubert","Schumann","Stravinsky","Tchaikovsky"};

// font
PFont   gFont1   = null;
PFont   gFont2   = null;
PFont   gFont3   = null;
public void setup()
{
  
  size(1024,768);
  background(10);
  frameRate(60);
  smooth();
  
  gFont1 = createFont("Arial", 11, false);
  gFont2 = createFont("Helvetica", 18, false);
  gFont3 = createFont("Arial", 15, false);
  
  horizontalSquareSize = width/horizontalGridDivisions;

  // for year: 2005-2011 => idx: 0-6
  // for month: 1-12 => idx: 0-11
  pResult_Bach          = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Bach[i][j] = new Integer(0);
  pResult_Beethoven     = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Beethoven[i][j] = new Integer(0);
  pResult_Chopin        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Chopin[i][j] = new Integer(0);
  pResult_Handel        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Handel[i][j] = new Integer(0);
  pResult_Haydn         = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Haydn[i][j] = new Integer(0);
  pResult_Mozart        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Mozart[i][j] = new Integer(0);
  pResult_Schubert      = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Schubert[i][j] = new Integer(0);
  pResult_Schumann      = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Schumann[i][j] = new Integer(0);
  pResult_Stravinsky    = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Stravinsky[i][j] = new Integer(0);
  pResult_Tchaikovsky   = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Tchaikovsky[i][j] = new Integer(0);

  Integer[][][] pDataMatrices = {
    pResult_Bach,
    pResult_Beethoven,
    pResult_Chopin,
    pResult_Handel,
    pResult_Haydn,
    pResult_Mozart,
    pResult_Schubert,
    pResult_Schumann,
    pResult_Stravinsky,
    pResult_Tchaikovsky  };
  gpDataMatrices = pDataMatrices;
  
  boolean[][][] pBarsMouseEvent = new boolean[gpDataMatrices.length][7][12];
  gpBarsMouseEvent = pBarsMouseEvent;
    
  String[] Filenames = {
    "query/Bach.txt",
    "query/Beethoven.txt",
    "query/Chopin.txt",
    "query/Handel.txt",
    "query/Haydn.txt",
    "query/Mozart.txt",
    "query/Schubert.txt",
    "query/Schumann.txt",
    "query/Stravinsky.txt",
    "query/Tchaikovsky.txt"};
    
  // get data
  for (int i=0; i<Filenames.length; i++ )  {
    
    // try to read local file
    println("reading "+Filenames[i]+"...");
    
    String [] textData = loadStrings(Filenames[i]);

    for( int j=1; j<textData.length; j++ )  {
      
      String textSplitted[] = split(textData[j], ",");
      
      int y = (int)Integer.parseInt(textSplitted[0]);
      int m = (int)Integer.parseInt(textSplitted[1]);
      int val = (int)Integer.parseInt(textSplitted[2]);
      
      Integer[][] dataMatrix = pDataMatrices[i];
      dataMatrix[y-2005][m-1] = val;
      
      // store maximum val to normalize
      if( gpMaxDataMatrices < val ) gpMaxDataMatrices = val;
      
//      println(y+" "+m+" "+dataMatrix[y-2005][m-1]);
    }
    
  }
  
  // animation
  gnTimeStart = millis();

}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Yoon_Project2_Final" });
  }
}
