import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class simpleInteraction3 extends PApplet {

// 2013 Winter MAT 259 Data Visualization
// Lab 4. 2D Space - simpleInteraction3
// Implemented by Joshua Dickinson, updated by Yoon Chung Han

//now we don't need the MySQL library

PFont font1 = createFont("Helvetica", 15); 
PFont font2 = createFont("Helvetica", 30);
int border = 20;
int[] transactionsPerDewey = new int[100];
boolean showGrid = false;
boolean leftMouseClicked = false;
boolean rightMouseClicked = false;
boolean addColor = false;
int displayMode = 0;

int padding = 10;
float horizontalGridDivisions = 8;
float verticalGridDivisions = 8;
float horizontalSquareSize;
float verticalSquareSize;

int color1;

public void setup() {
  size(900, 640); //size of the sketch window
  horizontalSquareSize = width/horizontalGridDivisions;
  verticalSquareSize = height/verticalGridDivisions;
  
  colorMode(HSB, 360,100,100); //color mode- like RGB or HSB (learn to use HSB because it's the best: http://en.wikipedia.org/wiki/HSL_and_HSV)
  smooth();

  //import the data from our text file 
  String savedData[] = loadStrings("savedData.txt");
  println("QUERY: " + savedData[0]);
  for (int i=1; i < savedData.length; i++) {
    
    String temp[] = split(savedData[i], ",");
    transactionsPerDewey[Integer.parseInt(temp[0])] = Integer.parseInt(temp[1]);
  }   
  
  color1 = color(0,60,60);
}

public void draw() {
    background(50,3,95);
   
   
   println(mouseX*360/width);
    if(addColor == true){
      drawColor();
      color1 = color(mouseX*360/width,70,mouseY*100/height);
    }      
    if(showGrid == true){
      drawGrid();
    }
    if(leftMouseClicked == true || rightMouseClicked == true){
      drawMouse();
    }
    
    if(displayMode == 1){    
    //draw dewey line graph
      stroke(0,0,0);
      strokeWeight(3.0f);
      strokeCap(SQUARE);
      for(int i = 0;i<100;i++){
        float tempX = (i*(width-horizontalSquareSize)/100)+padding; 
        line(tempX, height-padding, tempX, height-padding-transactionsPerDewey[i]*0.2f);
      }
    }
    if(displayMode == 2){
      stroke(0,0,0);
      strokeWeight(3.0f);
      for(int i = 1;i<100;i++){
        float tempX = ((i-1)*(width-horizontalSquareSize)/100)+padding;
        float tempX2 = (i*(width-horizontalSquareSize)/100)+padding;  
        line(tempX, height-padding-transactionsPerDewey[i-1]*0.2f, tempX2, height-padding-transactionsPerDewey[i]*0.2f);
      }      
    }
    if(displayMode == 3){
      stroke(0,0,0);
      strokeWeight(3.0f);
      for(int i = 1;i<100;i++){
        float tempX = ((i-1)*(width-horizontalSquareSize)/100)+padding;
        float tempX2 = (i*(width-horizontalSquareSize)/100)+padding;  
        //line(tempX, height-padding-transactionsPerDewey[i-1]*0.2, tempX2, height-padding-transactionsPerDewey[i]*0.2);
        fill(color1);
        ellipse(tempX2, height-padding-transactionsPerDewey[i]*0.2f, sqrt(transactionsPerDewey[i]), sqrt(transactionsPerDewey[i]));
      }      
    }    
    
    
    
    //vertical labels
    for(int i = 1;i<10;i++){
      fill(0);
      textAlign(RIGHT,CENTER);
      textFont(font1);
      text(i*500,width-padding, height-padding-(i*500*0.2f));        
    }
      
    //give it a title  
    //fill(0,0,0);
    fill(color1);  
    textAlign(LEFT,TOP);
    textFont(font2);
    text("Transactions by\nDewey Class on\nAugust 11, 2011",horizontalSquareSize*1+padding, verticalSquareSize*2+padding); 
}

public void drawGrid(){
  
  //draw horizontal grid
  stroke(0,0,70);
  strokeWeight(1.0f);
  for(int i = 0;i<=horizontalGridDivisions;i++){
    line(i*horizontalSquareSize-padding,0,i*horizontalSquareSize-padding, height);
    line(i*horizontalSquareSize+padding,0,i*horizontalSquareSize+padding, height);
  }

  //draw vertical grid
  stroke(0,0,70);
  strokeWeight(1.0f);
  for(int i = 0;i<=horizontalGridDivisions;i++){
    line(0,i*verticalSquareSize-padding,width, i*verticalSquareSize-padding);
    line(0,i*verticalSquareSize+padding,width, i*verticalSquareSize+padding);
  }
}

public void drawMouse(){
  
  if(leftMouseClicked == true){
    stroke(0,0,70);
    strokeWeight(1.0f);
    line(width,mouseY,0,mouseY);
    
    fill(0);
    textAlign(LEFT,BOTTOM);
    textFont(font1);
    text(-5*(mouseY-height+padding),padding, mouseY); 
  }
  
  if(rightMouseClicked == true){
    stroke(0,0,70);
    strokeWeight(1.0f);
    line(mouseX,height,mouseX,0);
    
    fill(0);
    textAlign(LEFT,TOP);
    textFont(font1);
    text(round(((mouseX-padding)*100)/(width-horizontalSquareSize)),mouseX+padding, padding); //(i*(width-horizontalSquareSize)/100)+padding   // x*(width-horizontal) = (mouseX-padding*100)/(width-horizontalSquareSize)
  }  
  
}

public void drawColor(){
  
  //add color
  fill(color1);
  rectMode(CORNERS);
  noStroke();
  //rect(0,0,padding,height);
  //rect(0,0,width,padding);
}


public void keyPressed(){
 //press spacebar to toggle the grid on and off  
 if(key == ' '){
   if(showGrid == true){
     showGrid = false;
   }
   else{showGrid = true;}
 } 
 
 if(key == 'c'){
   if(addColor == true){
     addColor = false;
   }
   else{addColor = true;}
 }
 if(key == '1'){
   displayMode = 1;
 } 
 if(key == '2'){
   displayMode = 2;
 }
 if(key == '3'){
   displayMode = 3;
 } 
 if(key == '4'){
   displayMode = 4;
 }  
}

public void mousePressed(){
  if(mouseButton == LEFT){
   if(leftMouseClicked == true){
     leftMouseClicked = false;
   }
   else{leftMouseClicked = true;}
  }
  
  if(mouseButton == RIGHT){
       if(rightMouseClicked == true){
     rightMouseClicked = false;
   }
   else{rightMouseClicked = true;}
  } 
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "simpleInteraction3" });
  }
}
